library angular2.src.web_workers.ui.setup;

import "package:angular2/src/web_workers/shared/messaging_api.dart"
    show SETUP_CHANNEL;
import "package:angular2/src/facade/async.dart"
    show EventEmitter, ObservableWrapper;
import "package:angular2/src/web_workers/shared/message_bus.dart"
    show MessageBus;
import "package:angular2/src/services/anchor_based_app_root_url.dart"
    show AnchorBasedAppRootUrl;
import "package:angular2/di.dart" show Injectable;

@Injectable()
class WebWorkerSetup {
  WebWorkerSetup(MessageBus bus, AnchorBasedAppRootUrl anchorBasedAppRootUrl) {
    var rootUrl = anchorBasedAppRootUrl.value;
    var sink = bus.to(SETUP_CHANNEL);
    var source = bus.from(SETUP_CHANNEL);
    ObservableWrapper.subscribe(source, (String message) {
      if (identical(message, "ready")) {
        ObservableWrapper.callNext(sink, {"rootUrl": rootUrl});
      }
    });
  }
}
